/*******************************************************************************
 * Copyright © 2011 Alexey Kaloshin. All Rights Reserved. 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 *  1. Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 
 *  2. Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution.
 * 
 *  3. The name of the author may not be used to endorse or promote 
 * products derived from this software without specific prior written permission. 
 * 
 *  THIS SOFTWARE IS PROVIDED BY Alexey Kaloshin "AS IS" AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/
package cz.nocach.swingmvp.integration;

import static org.testng.Assert.assertEquals;

import org.testng.annotations.Test;

import cz.nocach.swingmvp.autoinitiater.MvpAutoInitiater;
import cz.nocach.swingmvp.testobj.Person;
import cz.nocach.swingmvp.testobj.SimpleNameModel;
import cz.nocach.swingmvp.testobj.SimpleNamePresenter;
import cz.nocach.swingmvp.testobj.SimpleNameView;

public class ModelViewPresenterTest {
	@Test
	public void autoSetIsPerformedUsingViewPresenterAutoDelegation(){
		Person person = new Person();
		SimpleNamePresenter presenter = new SimpleNamePresenter(new SimpleNameView(), new SimpleNameModel(person));
		MvpAutoInitiater mvpAutoInitiater = new MvpAutoInitiater(presenter.getModel(), presenter.getView());
		mvpAutoInitiater.initViewPresenterAutoEventsDelegation(presenter.getView(), presenter);
		
		presenter.getView().getNameField().setText("must be auto-set through presenter");
		
		assertEquals(presenter.getModel().getName(), presenter.getView().getNameField().getText());
	}
}
