/*******************************************************************************
 * Copyright © 2011 Alexey Kaloshin. All Rights Reserved. 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 *  1. Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 
 *  2. Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution.
 * 
 *  3. The name of the author may not be used to endorse or promote 
 * products derived from this software without specific prior written permission. 
 * 
 *  THIS SOFTWARE IS PROVIDED BY Alexey Kaloshin "AS IS" AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/
package cz.nocach.swingmvp.testmodels;

import java.util.HashSet;
import java.util.Set;

import cz.nocach.swingmvp.model.listener.Listener;

public class BaseModelWithCustomListeners extends BaseTestModel{
	@Listener
	public BaseTestModelListener listener;
	@Listener
	public BaseTestModelListener listenerTwo;
	@Listener(type = BaseTestModelListener.class)
	public Set<BaseTestModelListener> collectionOfListeners = new HashSet<BaseTestModelListener>();
	@Listener
	public Listener1 listenerOfAnotherType;
	@Listener(type = Listener1.class)
	public Set<Listener1> collectionOfAnotherTypeListeners = new HashSet<Listener1>();
	
	public BaseTestModelListener getListener() {
		return listener;
	}
	public void setListener(BaseTestModelListener listener) {
		this.listener = listener;
	}
	public Listener1 getListenerOfAnotherType() {
		return listenerOfAnotherType;
	}
	public void setListenerOfAnotherType(Listener1 listenerOfAnotherType) {
		this.listenerOfAnotherType = listenerOfAnotherType;
	}
	public Set<BaseTestModelListener> getCollectionOfListeners() {
		return collectionOfListeners;
	}
	public void setCollectionOfListeners(
			Set<BaseTestModelListener> collectionOfListeners) {
		this.collectionOfListeners = collectionOfListeners;
	}
	public BaseTestModelListener getAnotherListener() {
		return listenerTwo;
	}
	public void setAnotherListener(BaseTestModelListener anotherListener) {
		this.listenerTwo = anotherListener;
	}
	
}