/*******************************************************************************
 * Copyright © 2011 Alexey Kaloshin. All Rights Reserved. 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 *  1. Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 
 *  2. Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the 
 * documentation and/or other materials provided with the distribution.
 * 
 *  3. The name of the author may not be used to endorse or promote 
 * products derived from this software without specific prior written permission. 
 * 
 *  THIS SOFTWARE IS PROVIDED BY Alexey Kaloshin "AS IS" AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/
package cz.nocach.swingmvp.testmodels;

import java.util.HashSet;
import java.util.Set;

import javax.swing.text.AsyncBoxView.ChildLocator;

import org.jmock.Mockery;

import cz.nocach.swingmvp.model.Model;
import cz.nocach.swingmvp.model.listener.Listener;

public class ModelWithMultipleListeners extends Model{
	@Listener
	public Listener1 listener1;
	@Listener
	public Listener1 listener1AnotherField;
	@Listener
	public Listener2 listener2;
	@Listener(type=ListenerParent.class)
	public Set<ListenerParent> listeners = new HashSet<ListenerParent>();
	@Listener(type=Listener2.class)
	public Set<Listener2> listenersListener2 = new HashSet<Listener2>();
	@Listener(type=Listener1.class)
	public Set<Listener1> listenersListener1 = new HashSet<Listener1>();
	public Set<Object> justAnotherSet = new HashSet<Object>();
	public Object anotherObject = new Object();
	public void clearAllListeners() {
		listener1 = null;
		listener2 = null;
		listeners = null;
	}
	public boolean hasAssignedListener1Value(Listener1 value) {
		if (listener1 == value) return true;
		if (listener1AnotherField == value) return true;
		if (listenersListener1 == null) return false;
		return listenersListener1.contains(value);
	}
	public boolean hasAssignedListener2Value(Listener2 value) {
		if (listener2 == value) return true;
		if (listenersListener2 == null) return false;
		return listenersListener2.contains(value);
	}
	public boolean hasSingleInstanceOfListener1(Listener1 instance) {
		return getNumberOfInstancesAssigned(instance) == 1;
	}
	public int getNumberOfInstancesAssigned(Listener1 instance) {
		int result = 0; 
		if (listener1 != null && listener1.equals(instance)) result++;
		if (listener1AnotherField != null && listener1AnotherField.equals(instance)) result++;
		if (listenersListener1 == null) return result;
		for(Listener1 each : listenersListener1){
			if (each != null && each.equals(instance)) result++;
		}
		return result;
	}
}
